MGT.aVersion = '1.0.10'

--#################################################################################################################################################
-- #############   Configuration 																				############### 
--#################################################################################################################################################

MGT.afacDetectionRadius			= 4000 -- meters
MGT.afacMarkDuration			= 300 -- seconds
MGT.afacControlRadius			= 5000 -- meters
MGT.afacDeconflictDistance		= 3500 -- meters
MGT.afacMinDistanceBetweenTargets = 3000 -- meters
--#################################################################################################################################################
-- #############   Initialization of globals																						############### 
--#################################################################################################################################################

MGT.afacControlData = {}
MGT.afacMenuRoots = {}
MGT.afacUnits = {}

-- defaults...load in the generation script
MGT.ROEchangeRadiusOnMark = 1000
MGT.maxWPmarkDist = 50
MGT.minWPmarkDist = 20

--#################################################################################################################################################
-- #############  Code																												############### 
--#################################################################################################################################################
function MGT.startAFAC(afacUnitName)
	local U = UNIT:FindByName(afacUnitName)
	local controlRow = 
				{
						name = afacUnitName
					,	state = 'startup'
					,	targetGroupName = nil 
					,	markTime = nil 
					,	lastTargetHealth = nil
					,	workGroup = nil
					, 	statusText = 'Patrolling'
					,	targetData = {
											groupName = nil
										,	unitName  = nil -- nil if infantry
										,	position  = nil -- if unitName != nil then positio is the unit position, if not, is the avg position of the group (to arget inf)
										,	template = nil 
										,	brief = nil
										
									}
				}
	MGT.afacControlData[afacUnitName] = controlRow
	table.insert(MGT.afacUnits,afacUnitName)
	
	
	env.error('MGT--> AFAC('..afacUnitName..') starting. Fuel State: '..U:GetFuel(),false)
	timer.scheduleFunction( MGT.afacControl, {afacUnitName},  timer.getTime() + mist.random(2,10) ) 
	
end --function
-----------------------------------------------------------------------------------------------------------------------------------------------------
function MGT.afacControl(params,time)
	local afacUnitName = params[1]
	local interval = 13
	local U = UNIT:FindByName(afacUnitName)
	-- check if AFAC is alive
	env.error('MGT--> AFAC('..afacUnitName..') Fuel State: '..U:GetFuel(),false)
	-- process state
	if MGT.afacControlData[afacUnitName].state == 'startup' then
		do
			MGT.afacControlData[afacUnitName].state = 'patrolling'
			MGT.afacControlData[afacUnitName].statusText = 'Patrolling'
		end
	elseif MGT.afacControlData[afacUnitName].state == 'patrolling' then
		do
			MGT.afacControlData[afacUnitName].statusText = 'Patrolling'
			local targetName,targetPos,targetBrief = MGT.afacGetTarget(afacUnitName)
			if targetName then
				env.error('MGT--> AFAC('..afacUnitName..') targeting:'..targetName ,false)
				
				MGT.afacControlData[afacUnitName].targetGroupName = targetName
				MGT.afacControlData[afacUnitName].lastTargetHealth = MGT.getGroupHealth(MGT.afacControlData[afacUnitName].targetGroupName)
				-- orbit target
				local TARGET = GROUP:FindByName(MGT.afacControlData[afacUnitName].targetGroupName)
				local C = TARGET:GetCoordinate()
								
		--C:MarkToAll('target', true) -- for testing
				local u = Unit.getByName(afacUnitName)
				local g = u:getGroup()
				local G = GROUP:FindByName(g:getName())
				local s = mist.vec.mag(u:getVelocity()) 
				local a = G:GetAltitude()
				local task = G:TaskOrbit(C, a, s)
				G:PushTask(task) 
				
				local grid = mist.tostringMGRS(coord.LLtoMGRS(coord.LOtoLL(C:GetVec3())), 2):gsub(string.char(9),'   '):gsub(' ','')				
				grid = string.sub(grid,4,10)
				local	msg = 'Uzi Control: All flights, '..u:getCallsign()..' is requesting assistance at grid '..grid..'\n'
				MGT.afacControlData[afacUnitName].statusText = 'Requesting assistance at grid '..grid
				MGT.messageToUnit('',msg,{},10)
				-- update menus
				MGT.afacMenusAdd(afacUnitName,0) -- for all groups

							
				
				MGT.afacControlData[afacUnitName].state = 'tracking'
				interval = 30
			else
				interval = 45
			end
		end
	elseif MGT.afacControlData[afacUnitName].state == 'tracking' then
		do
			-- check if target is alive
			if not MGT.isGroupAlive(MGT.afacControlData[afacUnitName].targetGroupName)  then
				local displayName = MGT.redGROUPS[MGT.afacControlData[afacUnitName].targetGroupName].displayName
				MGT.messageToUnit('',displayName..' destroyed.\nGood Job!',{},10)
				-- remove menus
				MGT.afacMenusRemove(afacUnitName, 0) -- for all groups

				MGT.afacControlData[afacUnitName].targetGroupName = nil 
				MGT.afacControlData[afacUnitName].markTime = nil 
				MGT.afacControlData[afacUnitName].lastTargetHealth = nil
				
				local u = Unit.getByName(afacUnitName)
				local g = u:getGroup()
				--local s = mist.vec.mag(u:getVelocity()) 
				local G = GROUP:FindByName(g:getName())
				G:PopCurrentTask()
				--G:TaskRouteToZone(MGT.afacControlData[afacUnitName].patrolZone, true, s, '')
				
				MGT.afacControlData[afacUnitName].state = 'patrolling'
				interval = 60
			else	-- check if shooter checked in
				if MGT.afacControlData[afacUnitName].workGroup then
					MGT.afacMenusRemove(afacUnitName, MGT.afacControlData[afacUnitName].workGroup) -- for all groups except for workGroup
					MGT.afacMenusWorkGroup(afacUnitName,MGT.afacControlData[afacUnitName].workGroup) -- for all groups
					MGT.afacControlData[afacUnitName].state = 'firstMark'
					interval = 20
				end
				
			end
		end		
	elseif MGT.afacControlData[afacUnitName].state == 'firstMark' then
		do
			MGT.afacControlData[afacUnitName].statusText = 'Prosecuting target'
			--get target position
			local TARGET = GROUP:FindByName(MGT.afacControlData[afacUnitName].targetGroupName)
			local pos, brief, height = MGT.wpMarkGroup(MGT.afacControlData[afacUnitName].targetGroupName)
			MGT.afacControlData[afacUnitName].markTime = timer.getTime()
				

			-- deconflict
			local C = TARGET:GetCoordinate()
			local correction = mist.utils.toDegree(C:GetNorthCorrectionRadians())
			local dir =  MGT.CardinalDirections[mist.random(1,MGT.rowCount(MGT.CardinalDirections))]
			local r = mist.random(1,100)
			local txtDir = ''
			local C2 = nil
			if r > 15 then
				C2 = C:Translate(MGT.afacDeconflictDistance+mist.random(-500,500)	, correction+dir.deg, true, false)	
				txtDir = dir.name..' of'
			else
				C2 = C
				txtDir = 'above'
			end
			local u = Unit.getByName(afacUnitName)
			local g = u:getGroup()
			local G = GROUP:FindByName(g:getName())
			local s = mist.vec.mag(u:getVelocity()) 
			local a = G:GetAltitude()
			local task =  G:TaskOrbit(C2, a, s) 
			G:PopCurrentTask()
			G:PushTask(task) 

			-- change ROE for units near the mark
			local UnitList = C:ScanUnits(MGT.ROEchangeRadiusOnMark)				
			UnitList:ForEachUnit(function (unit) MGT.setRedGroupROE(unit:GetGroup().GroupName, 100) end )
			
			brief = MGT.afacBrief(afacUnitName,pos,brief)	
			if r > 15 then
			else
			end
			brief = brief.."\n I'm orbiting "..txtDir..' the target at '..mist.utils.round(mist.utils.metersToFeet(a),-2)..'ft\nYour are clear hot if you have the target and FAC in sight'
			MGT.messageToUnit('',brief,{},15)
		
			
			MGT.afacControlData[afacUnitName].state = 'waitingBDA'
			interval = 30
		end
	elseif MGT.afacControlData[afacUnitName].state == 'waitingBDA' then	
		do
			MGT.afacControlData[afacUnitName].statusText = 'Prosecuting target'
			-- check if target is alive
			if not MGT.isGroupAlive(MGT.afacControlData[afacUnitName].targetGroupName)  then
				local displayName = MGT.redGROUPS[MGT.afacControlData[afacUnitName].targetGroupName].displayName
				local u = Unit.getByName(afacUnitName)
				MGT.messageToUnit('',u:getCallsign()..': '..displayName..' destroyed.\nGood Job!\nYou may depart.',{},10)
				
				local t = timer.getTime()
				local delta = t-MGT.afacControlData[afacUnitName].markTime
				
				MGT.afacControlData[afacUnitName].targetGroupName = nil 
				MGT.afacControlData[afacUnitName].markTime = nil 
				MGT.afacControlData[afacUnitName].lastTargetHealth = nil
				MGT.afacControlData[afacUnitName].workGroup = nil
				MGT.afacMenusRemove(afacUnitName,0)
				local g = u:getGroup()
				local G = GROUP:FindByName(g:getName())
				G:PopCurrentTask()
				
				MGT.afacControlData[afacUnitName].state = 'patrolling'
				interval = 60+delta
				env.error('MGT--> AFAC('..afacUnitName..') target destroyed' ,false)
			else	-- check if new mark is needed and if the target is damaged
				local t = timer.getTime()
				if (t - MGT.afacControlData[afacUnitName].markTime) > MGT.afacMarkDuration then
					 MGT.afacControlData[afacUnitName].state = 'Mark'
					 interval = 10
				end
				
				local h = MGT.getGroupHealth(MGT.afacControlData[afacUnitName].targetGroupName)
				if h < MGT.afacControlData[afacUnitName].lastTargetHealth then
					local u = Unit.getByName(afacUnitName)
					MGT.afacControlData[afacUnitName].lastTargetHealth = h
					MGT.messageToUnit('',u:getCallsign()..' good hits! Target damaged. Continue.',{},10)
				end				
			end
			-- check if shooter is alive if afac is still working with the group
			if MGT.afacControlData[afacUnitName].workGroup then
				if not MGT.isGroupAlive(MGT.playerGroupsByID[MGT.afacControlData[afacUnitName].workGroup]) then
					local t = timer.getTime()
					local delta = t-MGT.afacControlData[afacUnitName].markTime
					
					MGT.afacControlData[afacUnitName].targetGroupName = nil 
					MGT.afacControlData[afacUnitName].markTime = nil 
					MGT.afacControlData[afacUnitName].lastTargetHealth = nil
					MGT.afacControlData[afacUnitName].workGroup = nil
					MGT.afacMenusRemove(afacUnitName,0)
					local u = Unit.getByName(afacUnitName)
					local g = u:getGroup()
					local G = GROUP:FindByName(g:getName())
					G:PopCurrentTask()
					
					MGT.afacControlData[afacUnitName].state = 'patrolling'
					-- cooldown			
					if delta < 60 then
						interval = 60
					else
						interval = delta
					end
				end
			end
		end
	elseif MGT.afacControlData[afacUnitName].state == 'Mark' then
		do
			MGT.afacControlData[afacUnitName].statusText = 'Prosecuting target'
			--get target position
			local TARGET = GROUP:FindByName(MGT.afacControlData[afacUnitName].targetGroupName)
			local pos, brief , height = MGT.wpMarkGroup(MGT.afacControlData[afacUnitName].targetGroupName)
			MGT.afacControlData[afacUnitName].markTime = timer.getTime()
			local brief = MGT.afacBrief(afacUnitName,pos,brief)	
			brief = 'New mark on the ground!\n'..brief
			MGT.messageToUnit('',brief,{},15)
			
			MGT.afacControlData[afacUnitName].state = 'waitingBDA'
			interval = 30
		end
	end --process state 
	
	env.error('MGT--> AFAC('..afacUnitName..') '..MGT.afacControlData[afacUnitName].state ..' for '..interval,false)
	
	return timer.getTime() + interval	
end -- function
-----------------------------------------------------------------------------------------------------------------------------------------------------
function MGT.afacMenusAdd(afacUnitName,groupID)
	local u = Unit.getByName(afacUnitName)
	env.error('MGT.afacMenusAdd() AFAC('..afacUnitName..') GroupID: '..groupID,false)
	for gid,gname in pairs(MGT.playerGroupsByID ) do
		env.error('MGT.afacMenusAdd() AFAC('..afacUnitName..') gid: '..gid..' gname: '..gname,false)
		if groupID == 0 or groupID == gid then
			if not MGT.afacMenuRoots[gid] then
				MGT.afacMenuRoots[gid] = {}
				env.error('MGT.afacMenusAdd() AFAC('..afacUnitName..') gid: '..gid..' gname: '..gname..' gid root init',false)
			end	--if not MGT.afacMenuRoots[gid] then
			if not MGT.afacMenuRoots[gid][afacUnitName] then
				MGT.afacMenuRoots[gid][afacUnitName] = {}
				env.error('MGT.afacMenusAdd() AFAC('..afacUnitName..') gid: '..gid..' gname: '..gname..' afac root init',false)
			end --if not MGT.afacMenuRoots[gid][afacUnitName] then	
			local groupRoot =  missionCommands.addSubMenuForGroup(gid, u:getCallsign(), nil)
			local smokeRoot = missionCommands.addCommandForGroup(gid, 'mark your position', groupRoot ,  MGT.afacSmokeStart, afacUnitName)
			local checkinRoot = missionCommands.addCommandForGroup(gid, 'Check-in', groupRoot ,  MGT.afacCheckIn, {afacUnitName,gid})
			MGT.afacMenuRoots[gid][afacUnitName] = {
												groupRoot = groupRoot, 
												smokeRoot= smokeRoot, 
												checkinRoot = checkinRoot,
												checkoutRoot = nil
													}
			env.error('MGT.afacMenusAdd() AFAC('..afacUnitName..') gid: '..gid..' gname: '..gname..' added',false)											
		end -- if groupID == 0 or groupID == gid then
	end -- for _,gid in pairs(MGT.playerGroups ) do

end -- function
-----------------------------------------------------------------------------------------------------------------------------------------------------
function MGT.afacMenusRemove(afacUnitName,groupID)

	for gid,gname in pairs(MGT.playerGroupsByID ) do
		if groupID == gid  then
			-- remove check-in for the already checked in group
				if MGT.afacMenuRoots[gid] then
					if MGT.afacMenuRoots[gid][afacUnitName] then
						missionCommands.removeItemForGroup(gid,MGT.afacMenuRoots[gid][afacUnitName].checkinRoot)
					end
				end
			else
			-- remove all
			if MGT.afacMenuRoots[gid] then
				if MGT.afacMenuRoots[gid][afacUnitName] then
					missionCommands.removeItemForGroup(gid,MGT.afacMenuRoots[gid][afacUnitName].groupRoot)	
				end
			end
		end
	end
end -- function
-----------------------------------------------------------------------------------------------------------------------------------------------------
function MGT.afacMenusWorkGroup(afacUnitName,groupID)
	MGT.afacMenuRoots[groupID][afacUnitName].checkoutRoot =  missionCommands.addCommandForGroup(groupID, 'Check-out', MGT.afacMenuRoots[groupID][afacUnitName].groupRoot ,  MGT.afacCheckOut, {afacUnitName,groupID})
end -- function
-----------------------------------------------------------------------------------------------------------------------------------------------------
function MGT.afacSmokeStart(afacUnitName)
	local u = Unit.getByName(afacUnitName)
	local g = u:getGroup()
	
	 local smoke_on = { 
						  id = 'SMOKE_ON_OFF', 
						  params = { 
							value = true 
						  } 
						}
	 g:getController():setCommand(smoke_on) 
	-- env.error('MGT--> AFAC('..afacUnitName..') smoke start' ,false)
	 timer.scheduleFunction( MGT.afacSmokeStop, {afacUnitName},  timer.getTime() + 10 ) 
	 MGT.messageToUnit('',u:getCallsign()..': Roger. Smoke for 10',{},10)
	 
end -- function
-----------------------------------------------------------------------------------------------------------------------------------------------------
function MGT.afacSmokeStop(params,time)
	local afacUnitName = params[1] 
	local u = Unit.getByName(afacUnitName)
	local g = u:getGroup()
	
	 local smoke_off = { 
						  id = 'SMOKE_ON_OFF', 
						  params = { 
							value = false 
						  } 
						}
	 env.error('MGT--> AFAC('..afacUnitName..') smoke stop' ,false)
	 g:getController():setCommand(smoke_off) 
	-- MGT.messageToUnit('','smoke off',{},10)
	return nil
end-- function
-----------------------------------------------------------------------------------------------------------------------------------------------------
function MGT.afacCheckIn(params)
	local afacUnitName = params[1] 
	local gid = params[2] 
	local u = Unit.getByName(afacUnitName)
	MGT.messageToUnit('',u:getCallsign()..': Roger. Rolling in to mark the target',{},15)
	MGT.afacControlData[afacUnitName].workGroup = gid
	env.error('MGT--> AFAC('..afacUnitName..') group:'..gid..' checked-in' ,false)
	-- mesage here
	
end -- function
-----------------------------------------------------------------------------------------------------------------------------------------------------
function MGT.afacCheckOut(params)
	local afacUnitName = params[1] 
	local gid = params[2] 
	local u = Unit.getByName(afacUnitName)
	MGT.messageToUnit('',u:getCallsign()..': Roger. You may depart',{},15)
	MGT.afacControlData[afacUnitName].workGroup = nil
	MGT.afacControlData[afacUnitName].state = 'cooldown'
	timer.scheduleFunction( MGT.afacCoolDown, {afacUnitName},  timer.getTime() + 60 ) 
	MGT.afacMenusRemove(afacUnitName, 0) -- for all groups

	MGT.afacControlData[afacUnitName].targetGroupName = nil 
	MGT.afacControlData[afacUnitName].markTime = nil 
	MGT.afacControlData[afacUnitName].lastTargetHealth = nil
	
	local u = Unit.getByName(afacUnitName)
	local g = u:getGroup()
	local G = GROUP:FindByName(g:getName())
	G:PopCurrentTask()
	env.error('MGT--> AFAC('..afacUnitName..') group:'..gid..' checked-out' ,false)
end --function
-----------------------------------------------------------------------------------------------------------------------------------------------------
function MGT.afacCoolDown(params,time)
	local afacUnitName = params[1]
	MGT.afacControlData[afacUnitName].state = 'patrolling'
	env.error('MGT--> AFAC('..afacUnitName..') cooldown end' ,false)
	return nil
end --function
-----------------------------------------------------------------------------------------------------------------------------------------------------
function MGT.afacGetTarget(afacUnitName)
	local detectedGroupName = nil
	local UnitZoneTable = MGT.getUnitZoneTable()
	local nUnits = MGT.rowCount(UnitZoneTable)
	local nAFACs = MGT.rowCount(MGT.afacUnits)
	local rt = {}
	local nrt = 0	
	local detUnits = {}
	local targetPos = nil
	local targetBrief = nil
	
	if nUnits > 0 then

		for i = 1,nAFACs do
			 rt = mist.getUnitsInMovingZones(UnitZoneTable, {afacUnitName}, MGT.afacDetectionRadius, 'cylinder')
			 nrt = MGT.rowCount(rt)
			 if nrt > 0 then
				for j = 1,nrt do 
					table.insert(detUnits, {afac = MGT.afacUnits[i], unit = rt[j] })
				end 
			 end
		end -- for i = 1,nAFACs,1 do
	
		nrt = MGT.rowCount(detUnits)
		if nrt > 0 then
			local p = mist.random(1,nrt)
			detectedGroupName = detUnits[p].unit:getGroup():getName()
		end						
		
	end -- if nUnits > 0 then
	
	-- check if is a valid target
	for n,r in pairs (MGT.afacControlData) do
		if n ~= afacUnitName and r.targetGroupName then
			if r.targetGroupName == detectedGroupName then
				detectedGroupName = nil
			--elseif mist.utils.get2DDist(mist.getLeadPos(r.targetGroupName),mist.getLeadPos(detectedGroupName)) <= MGT.afacMinDistanceBetweenTargets then
			--	detectedGroupName = nil
			end
		end
	end 
	
	return detectedGroupName,targetPos,targetBrief
end -- function
-----------------------------------------------------------------------------------------------------------------------------------------------------
function MGT.afacBrief(afacUnitName, markPos, markPosTXT)
	local msg = ''
	local M = COORDINATE:NewFromVec3(markPos)
	local displayName = MGT.redGROUPS[MGT.afacControlData[afacUnitName].targetGroupName].displayName	
	local grid = mist.tostringMGRS(coord.LLtoMGRS(coord.LOtoLL(markPos)), 2):gsub(string.char(9),'   '):gsub(' ','')
	local u = Unit.getByName(afacUnitName)
	
	grid = string.sub(grid,4,10)
	
	msg = u:getCallsign()..': designating target:\n'..displayName..'\n'
	msg = msg.. 'Grid: '..grid..' \nMarked with WP.\n'..markPosTXT..'\n'	
	
	return msg

end --function
-----------------------------------------------------------------------------------------------------------------------------------------------------
function MGT.showAFACstatus(_unitName)
	local msg = ''
	if MGT.rowCount( MGT.afacControlData) > 0 then
		for afacUnitName,afacData in pairs(MGT.afacControlData) do
			local u = Unit.getByName(afacUnitName)
			msg = msg..u:getCallsign()..': '..MGT.afacControlData[afacUnitName].statusText..'\n'
		end
	end
	if  msg == '' then
		msg = 'No status available yet'
	end
	MGT.messageToUnit(_unitName,msg,{},30)
end
-----------------------------------------------------------------------------------------------------------------------------------------------------
function MGT.wpMarkGroup(_groupName)
	local tgtPos = mist.getAvgPos(MGT.getUnitNames(_groupName))
	local markPos =  mist.utils.makeVec3GL(mist.getRandPointInCircle(tgtPos,MGT.maxWPmarkDist,MGT.minWPmarkDist,0,360))
	local _dir = mist.utils.toDegree(mist.utils.getDir(mist.vec.sub(tgtPos, markPos)))
	local _dist = mist.utils.get2DDist(markPos,tgtPos)
	local _direction = ''
	local height =  land.getHeight({x = tgtPos.x, y = tgtPos.z})
	

	if _dir >= 0 and _dir <  22 then
			_direction = 'North'
		elseif _dir >= 22 and _dir <  68 then
			_direction = 'North East'
		elseif _dir >= 68 and _dir <  113 then
			_direction = 'East'
		elseif _dir >= 113 and _dir <  158 then
			_direction = 'South East'
		elseif _dir >= 158 and _dir <  203 then
			_direction = 'South'
		elseif _dir >= 203 and _dir <  248 then
			_direction = 'South West'
		elseif _dir >= 248 and _dir <  293 then
			_direction = 'West'
		elseif _dir >= 293 and _dir <  338 then
			_direction = 'North West'
		elseif _dir >= 338 and _dir <=  360 then
			_direction = 'North'
	end

	_dist = math.floor(_dist / 10) * 10	
	local heightFT = math.floor(height*3.281 / 10) * 10	
	local briefing = string.format("Target is %im, %s from my mark, elevation:%sft", _dist, _direction,heightFT)	
	trigger.action.smoke(markPos, trigger.smokeColor.White )
	return tgtPos, briefing, height
end -- function
-----------------------------------------------------------------------------------------------------------------------------------------------------
--#################################################################################################################################################
-- #############   Main body   																										############### 
--#################################################################################################################################################
--
do

	missionCommands.addCommand("Display AFAC Status",nil, MGT.showAFACstatus, '') 
	-- Show AFAC Status
	trigger.action.outText( 'AFAC - v'..MGT.aVersion, 1 )
end
