MGT.gVersion = '1.0.9'

-- mission specific functions 
-- load order :
-- 1 MissionGeneratorTools
-- 2 Templates
-- 3 this script

--#################################################################################################################################################
-- #############   Configuration (mission specific)																					############### 
--#################################################################################################################################################

MGT.Era							= 2 	-- 2 = Modern , 1 = Cold war
MGT.border						= 'CPLA-AOR'
MGT.MinInsurgentSites			= 6		-- Min Number of insurgent Sites to be deployed
MGT.MaxInsurgentSites			= 10	-- Max Number of insurgent Sites to be deployed
MGT.SiteRadius					= 250	--meters
MGT.FortAsCenterProb			= 50 	--% of probability that the site will be centered in a fortification
MGT.ADAprob						= 40	--% of probability that the site has ADA
MGT.MinADA						= 1	
MGT.MaxADA						= 2
MGT.ARTprob						= 50	--% of probability that the site has ADA
MGT.MinART						= 1	
MGT.MaxART						= 1
MGT.MANPADprob					= 20	--% of probability that the site has Manpads
MGT.MinMANPAD					= 1	
MGT.MaxMANPAD					= 1
MGT.ConvoyZones 				= 16
MGT.CONVOYprob					= 30	--% of probability for convoy
MGT.MinCONVOY					= 1	
MGT.MaxCONVOY					= 3
MGT.MinINSgroups				= 2		-- Min number of insurgent infantry groups per 
MGT.MaxINSgroups				= 4		-- Max number of insurgent infantry groups per 
MGT.Zones						= 8
--MGT.DetectionRadius				= 4000 -- meters
MGT.ROEchangeRadiusOnShot		= 750 -- meters
MGT.ROEchangeRadiusOnMark		= 250 -- meters
MGT.minWPmarkDist				= 20
MGT.maxWPmarkDist				= 50
MGT.redOpenFireROEprob			= 20 --%
MGT.redOpenFireROEprobADA		= 40 --%
MGT.blueZones 					= 80
MGT.minBluePatrols				= 10
MGT.maxBluePatrols				= 20
MGT.afacDetectionRadius			= 4000 -- meters
MGT.afacMarkDuration			= 300 -- seconds
MGT.afacControlRadius			= 5000 -- meters
MGT.afacDeconflictDistance		= 3500 -- meters
MGT.afacMinDistanceBetweenTargets = 3000 -- meters

--#################################################################################################################################################
-- #############   Initialization of globals (mission specific)																		############### 
--#################################################################################################################################################
MGT.blueGROUPS = {}
MGT.redGROUPS = {}
MGT.playerUnits = {}
MGT.playerGroups = {}
MGT.playerGroupsByID = {}


--#################################################################################################################################################
-- #############   Event Handlers											 	  													############### 
--#################################################################################################################################################
MGT.EventHandler = {}
function MGT.EventHandler:onEvent(_eventDCS)

	if _eventDCS == nil or _eventDCS.initiator == nil then
		return true
	end

	local status, err = pcall(function(_event)

			if (_event.id == world.event.S_EVENT_BIRTH  or _event.id == world.event.S_EVENT_TAKEOFF 
				or  _event.id == world.event.S_EVENT_ENGINE_STARTUP) and _event.initiator:getPlayerName()  then  

				MGT.initUnit(_event.initiator:getName())
				
			elseif ( _event.id == world.event.S_EVENT_SHOOTING_START ) or (_event.id == world.event.S_EVENT_SHOT) then 
				MGT.ShootingEvent(_event)
			--elseif (_event.id == world.event.S_EVENT_DEAD) then 
			--	MGT.DeadEvent(_event)
			elseif (_event.id == world.event.S_EVENT_EJECTION or _event.id == world.event.S_EVENT_PILOT_DEAD ) and _event.initiator:getPlayerName() then 	
				MGT.showScore(_event.initiator:getName())		
			end --if (_event.id ==
								
		  -- ### End event processing

			return true
	end, _eventDCS) --  local status, err = pcall(function(_event)

	if (not status) then 
		local msg = string.format("Strike Mission Generator (v%s): Error while handling event %s",MGT.Version, err)
		env.error(msg,true)
	end
end
-----------------------------------------------------------------------------------------------------------------------------------------------------
function MGT.ShootingEvent(_event)
	local shooterName = _event.initiator:getName()
	local UnitZoneTable = MGT.getUnitZoneTable('ALL')	
	
	local t = mist.getUnitsInMovingZones(UnitZoneTable, {shooterName}, MGT.ROEchangeRadiusOnShot, 'cylinder')
	for i = 1,MGT.rowCount(t) do
		MGT.setGroupOption(t[i]:getGroup():getName(),0,2) -- open fire
	end --for i = 1,MGT.rowCount(t) do
	
end --function
-----------------------------------------------------------------------------------------------------------------------------------------------------
function MGT.DeadEvent(_event)
	local Name = _event.initiator:getName()
	local Type = _event.initiator:getTypeName()
	local _status,coaliton = pcall(function()
							return {_event.initiator:getCoalition()}
							end)	
	if not _status then
		coalition = 0	
	end 
	

	
	if coalition ~= 0 then
		if Type then
			trigger.action.outText(string.format('%s (%s) destroyed',Name,Type), 10)
		else
			trigger.action.outText(string.format('%s destroyed',Name), 10)
		end
	end
	
end -- function
-----------------------------------------------------------------------------------------------------------------------------------------------------
function MGT.initUnit(unitName)
	local unit = Unit.getByName(unitName)
	local groupID = unit:getGroup():getID()
	local groupName = unit:getGroup():getName()
	local unitType =  unit:getTypeName()
	local side = unit:getCoalition()
	local clientConfig = {
								groupID = groupID
							,	unitType = unitType
							,	side = side
						}
		
	if not MGT.clientConfig[unitName] then -- new player
		dummy = 0
		
	else -- returning player
		dummy = 0
	end

	if not MGT.inTable(unitName,MGT.playerUnits) then
		table.insert(MGT.playerUnits,unitName)
		if not MGT.inTable(groupID,MGT.playerGroups) then
			table.insert(MGT.playerGroups,groupID)
			MGT.playerGroupsByID[groupID] = groupName
		end
	end
	
	-- Check if AFAC menus need to be added
	if MGT.rowCount( MGT.afacControlData) > 0 then
		for afacUnitName,afacData in pairs(MGT.afacControlData) do
			if afacData.state == 'tracking' then
				MGT.afacMenusAdd(afacUnitName,0) 
			end
		end--for afacUnitName,afacData in pairs(MGT.afacControlData) do
	end -- if MGT.rowCount( MGT.afacControlData) > 0 then

	MGT.clientConfig[unitName] = clientConfig
	return true
end
--#################################################################################################################################################
-- #############   mission generation code									 	  													############### 
--#################################################################################################################################################
function MGT.addGroups(_groupData, _side)
	local h,n  = MGT.getGroupHealth(_groupData.name)
	
	local row = {
				name 		= _groupData.name
			,	displayName = _groupData.template.displayName
			,	position	= _groupData.pos
			,	health0		= h
		--	,	health		= h
			, 	isTarget	= false
			, 	unitCount0 = n
		}
		
	if _side == 1 then
		MGT.redGROUPS[row.name] = row
	elseif _side == 2 then
		MGT.blueGROUPS[row.name] = row
	end
end-- function
-----------------------------------------------------------------------------------------------------------------------------------------------------
function MGT.deployInsurgents()
	local siteCenter = {}
	local templates = {}
	local template = {}
	local deployedGroups = {}
	local n = 0
	local zone = nil
	local prob = 0
	local MaxINSgroups = 0
	local nGrp = 0
	local r = {}
	local G = mist.random(MGT.MinInsurgentSites,MGT.MaxInsurgentSites) 
	local z = 0
	-- Deploy Insurgent Groups
	
	for i = 1, G , 1 do
		env.error(string.format('MGT.deployInsurgents(): Deploying %s sites', G),false)
		MaxINSgroups = MGT.MaxINSgroups
		groupCenter = {}
		z = mist.random(1,MGT.Zones)
		zone = trigger.misc.getZone('insZone-'..z)
		prob = mist.random(1,100)
		if prob <= MGT.FortAsCenterProb then
			--trigger.action.outText( 'fort', 1 )
			env.error('MGT.deployInsurgents(): Center is a FORT',false)
			templates, n = MGT.getTemplateList ({'FORT'}, 1, MGT.Era)
			template = templates[mist.random(1,n)]
			deployedGroups = MGT.populateLand({template}, 1, zone.point, MGT.border	, 0, zone.radius, 0,0,0)
		else -- use an Ins group as site center
			--trigger.action.outText( 'ins', 1 )
			env.error('MGT.deployInsurgents(): Center is a INS',false)
			templates, n = MGT.getTemplateList ({'INS'}, 1, MGT.Era)
			template = templates[mist.random(1,n)]
			deployedGroups = MGT.populateLand({template}, 1, zone.point, MGT.border	, 0, zone.radius, 0,0,0)	
			MaxINSgroups = MaxINSgroups - 1			
		end -- if prob <= MGT.FortAsCenterProb then
		r = deployedGroups[1]
		if r then
			siteCenter = r.pos
			MGT.setRedGroupROE(r.name,MGT.redOpenFireROEprob)
			-- Deploy INS groups
			nGrp = mist.random(MGT.MinINSgroups,MaxINSgroups)
			env.error(string.format('MGT.deployInsurgents(): Deploying %s INS groups', nGrp),false)
			templates, n = MGT.getTemplateList ({'INS'}, 1, MGT.Era)
			template = templates[mist.random(1,n)]
			deployedGroups = MGT.populateLand(templates, nGrp, siteCenter, MGT.border	, 10, MGT.SiteRadius, 0,0,0)	
			nGrp = MGT.rowCount(deployedGroups) 
			if  nGrp> 0 then
				for j = 1,nGrp,1 do
					r = deployedGroups[j]
					MGT.setRedGroupROE(r.name, MGT.redOpenFireROEprob)
					MGT.addGroups(r,1)-- group to red list	
				end	
			end
			
			-- ADA
			prob = mist.random(1,100)
			if prob <= MGT.ADAprob	 then
				nGrp = mist.random(MGT.MinADA,MGT.MaxADA)
				env.error(string.format('MGT.deployInsurgents(): Deploying  %s ADA groups', nGrp),false)
				templates, n = MGT.getTemplateList ({'ADA'}, 1, MGT.Era)
				template = templates[mist.random(1,n)]
				deployedGroups = MGT.populateLand(templates, nGrp, siteCenter, MGT.border	, 10, MGT.SiteRadius, 0,0,0)	
				nGrp = MGT.rowCount(deployedGroups) 
				if  nGrp> 0 then
					for j = 1,nGrp,1 do
						r = deployedGroups[j]
						MGT.setRedGroupROE(r.name,MGT.redOpenFireROEprobADA)
						MGT.addGroups(r,1)-- group to red list	
					end	
				end									
			end -- if prob <= MGT.ADAprob	 then
			-- ART
			prob = mist.random(1,100)
			if prob <= MGT.ARTprob	 then
				nGrp = mist.random(MGT.MinART,MGT.MaxART)
				env.error(string.format('MGT.deployInsurgents(): Deploying  %s ART groups', nGrp),false)
				templates, n = MGT.getTemplateList ({'ART'}, 1, MGT.Era)
				template = templates[mist.random(1,n)]
				deployedGroups = MGT.populateLand(templates, nGrp, siteCenter, MGT.border	, 10, MGT.SiteRadius, 0,0,0)	
				nGrp = MGT.rowCount(deployedGroups) 
				if  nGrp> 0 then
					for j = 1,nGrp,1 do
						r = deployedGroups[j]
						MGT.setRedGroupROE(r.name,MGT.redOpenFireROEprob)
						MGT.addGroups(r,1)-- group to red list	
					end	
				end									
			end -- if prob <= MGT.ADAprob	 then
			
		
			-- MANPAD
			prob = mist.random(1,100)
			if prob <= MGT.MANPADprob	 then
				nGrp = mist.random(MGT.MinMANPAD,MGT.MaxMANPAD)
				env.error(string.format('MGT.deployInsurgents(): Deploying  %s MANPAD groups', nGrp),false)
				templates, n = MGT.getTemplateList ({'MANPAD'}, 1, MGT.Era)
				template = templates[mist.random(1,n)]
				deployedGroups = MGT.populateLand(templates, nGrp, siteCenter, MGT.border	, 10, MGT.SiteRadius, 0,0,0)	
				nGrp = MGT.rowCount(deployedGroups) 
				if  nGrp> 0 then
					for j = 1,nGrp,1 do
						r = deployedGroups[j]
						MGT.setRedGroupROE(r.name,MGT.redOpenFireROEprobADA)
						MGT.addGroups(r,1)-- group to red list	
					end	
				end									
			end -- if prob <= MGT.ADAprob	 then		
		end -- if r then
	end -- for i = 1, MGT.InsurgentSites , 1 do	
	-- Convoy 
	prob = mist.random(1,100)
	if prob <= MGT.CONVOYprob	 then					
		nGrp = 1--mist.random(MGT.MinCONVOY	,MGT.MaxCONVOY)
		z = mist.random(1,MGT.ConvoyZones)
		zone = trigger.misc.getZone('convoy-'..z)
		env.error(string.format('MGT.deployInsurgents(): Deploying  %s CONV groups', nGrp),false)
		templates, n = MGT.getTemplateList ({'CONV'}, 1, MGT.Era)
		template = templates[mist.random(1,n)]
		deployedGroups = MGT.populateLand(templates, nGrp, zone.point, MGT.border	, 0, zone.radius, 0,0,0)
		nGrp = MGT.rowCount(deployedGroups) 
		if  nGrp> 0 then
			for j = 1,nGrp,1 do
				r = deployedGroups[j]
				MGT.setRedGroupROE(r.name,MGT.redOpenFireROEprobADA)
				MGT.addGroups(r,1)-- group to red list	
			end	
		end		
	end -- 	if prob <= MGT.CONVOYprob	 then
	--trigger.action.outText( mist.utils.tableShow(MGT.redGROUPS), 1 )
	--trigger.action.outText( 'Insurgents Deployed', 1 )
end -- function
-----------------------------------------------------------------------------------------------------------------------------------------------------
function MGT.deployBlueForces()
	local n = mist.random(MGT.minBluePatrols,MGT.maxBluePatrols)
	for i = 1,n do
		local z = mist.random(1, MGT.blueZones)
		local zone = trigger.misc.getZone('Blue Patrol-'..z)
		local templates, n = MGT.getTemplateList ({'PATROL'}, 2, MGT.Era)
		local template = templates[mist.random(1,n)]
		local deployedGroups = MGT.populateLand(templates, 1, zone.point, MGT.border	, 0, zone.radius*5, 0,0,0)
		local nGrp = MGT.rowCount(deployedGroups) 
		if  nGrp> 0 then
			for j = 1,nGrp,1 do
				r = deployedGroups[j]
				MGT.addGroups(r,2)-- group to blue list	
			end	
		end	
	end -- for _,i in pairs(zones) do
	--trigger.action.outText( 'Blue forces Deployed', 1 )
end --function
-----------------------------------------------------------------------------------------------------------------------------------------------------
function MGT.getUnitZoneTable(_side)
	-- get one alive unit per red group
	local side = _side
	if not side then
		side = 'RED'
	end
	local t = {}
	if side == 'RED' or side == 'ALL' then 
		for _,v in pairs(MGT.redGROUPS) do
			local g = Group.getByName(v.name)
			if g then
				for _,unit in pairs(g:getUnits()) do
					if unit:getLife() >= 1 then
						table.insert(t,unit:getName())
						break
					end
				end --for _,unit in pairs(g) do
			end
		end --for _,v in pairs(MGT.redGROUPS) do
	end--if side =- 'RED' or side =- 'ALL' then 
	if side == 'BLUE' or side == 'ALL' then 
		for _,v in pairs(MGT.blueGROUPS) do
			local g = Group.getByName(v.name)
			if g then
				for _,unit in pairs(g:getUnits()) do
					if unit:getLife() >= 1 then
						table.insert(t,unit:getName())
						break
					end
				end --for _,unit in pairs(g) do
			end
		end --for _,v in pairs(MGT.redGROUPS) do
	end--if side =- 'BLUE' or side =- 'ALL' then 
	return t
end -- function
-----------------------------------------------------------------------------------------------------------------------------------------------------
function MGT.setRedGroupROE(_groupName, prob)
	if mist.random(1,100) <= prob then
		MGT.setGroupOption(_groupName, 0,2) -- open fire
	else
		MGT.setGroupOption(_groupName, 0,3) -- return fire
	end
end --function
-----------------------------------------------------------------------------------------------------------------------------------------------------
function MGT.showScore(_unitName)
	local DT = 0
	local TOO = 0
	local H0 = 0
	local H = 0
	local N0 = 0
	local N = 0
	local msg = ''
	
	-- agregate data
	for _,grpdata in pairs(MGT.redGROUPS) do
		local h,n =  MGT.getGroupHealth(grpdata.name)
		H0 = H0 + grpdata.health0
		H = H + h
		N0 = N0 + grpdata.unitCount0 
		N = N + n
		if h <=0 then
			if grpdata.isTarget then
				DT = DT + 1
			else
				TOO = TOO + 1
			end
		end
	end
	
	msg = 'Score\n'
	msg = string.format('%sDesignated targets destroyed: %s\n',msg,DT)
	msg = string.format('%sTargets of oportunity destroyed: %s\n',msg,TOO)
	msg = string.format('%sUnits destroyed: %s\n',msg,(N0-N))
	msg = string.format('%sEnemy Strength: %s%%\n',msg,mist.utils.round(H*100/H0, 2))
	
	MGT.messageToUnit(_unitName,msg,{},30)
end-- function
-----------------------------------------------------------------------------------------------------------------------------------------------------

--#################################################################################################################################################
-- #############   Main body   																										############### 
--#################################################################################################################################################
--
do
	-- init global menu (
	-- load event handler
	world.addEventHandler(MGT.EventHandler)

	--timer.scheduleFunction( MGT.detect, {},  timer.getTime() + 10 ) 
	missionCommands.addCommand("CoIn: Display Score",nil, MGT.showScore, '') 
	-- Show AFAC Status
	trigger.action.outText( 'bg_CyprusCoIn_generation - v'..MGT.gVersion, 1 )
end
